<?php

namespace Api\Aramex\Location\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CitiesFetchingResponse StructType
 * @subpackage Structs
 */
class CitiesFetchingResponse extends AbstractStructBase
{
    /**
     * The Transaction
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Api\Aramex\Location\StructType\Transaction
     */
    public $Transaction;
    /**
     * The Notifications
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Api\Aramex\Location\ArrayType\ArrayOfNotification
     */
    public $Notifications;
    /**
     * The HasErrors
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $HasErrors;
    /**
     * The Cities
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Api\Aramex\Location\ArrayType\ArrayOfstring
     */
    public $Cities;
    /**
     * Constructor method for CitiesFetchingResponse
     * @uses CitiesFetchingResponse::setTransaction()
     * @uses CitiesFetchingResponse::setNotifications()
     * @uses CitiesFetchingResponse::setHasErrors()
     * @uses CitiesFetchingResponse::setCities()
     * @param \Api\Aramex\Location\StructType\Transaction $transaction
     * @param \Api\Aramex\Location\ArrayType\ArrayOfNotification $notifications
     * @param bool $hasErrors
     * @param \Api\Aramex\Location\ArrayType\ArrayOfstring $cities
     */
    public function __construct(\Api\Aramex\Location\StructType\Transaction $transaction = null, \Api\Aramex\Location\ArrayType\ArrayOfNotification $notifications = null, $hasErrors = null, \Api\Aramex\Location\ArrayType\ArrayOfstring $cities = null)
    {
        $this
            ->setTransaction($transaction)
            ->setNotifications($notifications)
            ->setHasErrors($hasErrors)
            ->setCities($cities);
    }
    /**
     * Get Transaction value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Api\Aramex\Location\StructType\Transaction|null
     */
    public function getTransaction()
    {
        return isset($this->Transaction) ? $this->Transaction : null;
    }
    /**
     * Set Transaction value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Api\Aramex\Location\StructType\Transaction $transaction
     * @return \Api\Aramex\Location\StructType\CitiesFetchingResponse
     */
    public function setTransaction(\Api\Aramex\Location\StructType\Transaction $transaction = null)
    {
        if (is_null($transaction) || (is_array($transaction) && empty($transaction))) {
            unset($this->Transaction);
        } else {
            $this->Transaction = $transaction;
        }
        return $this;
    }
    /**
     * Get Notifications value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Api\Aramex\Location\ArrayType\ArrayOfNotification|null
     */
    public function getNotifications()
    {
        return isset($this->Notifications) ? $this->Notifications : null;
    }
    /**
     * Set Notifications value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Api\Aramex\Location\ArrayType\ArrayOfNotification $notifications
     * @return \Api\Aramex\Location\StructType\CitiesFetchingResponse
     */
    public function setNotifications(\Api\Aramex\Location\ArrayType\ArrayOfNotification $notifications = null)
    {
        if (is_null($notifications) || (is_array($notifications) && empty($notifications))) {
            unset($this->Notifications);
        } else {
            $this->Notifications = $notifications;
        }
        return $this;
    }
    /**
     * Get HasErrors value
     * @return bool|null
     */
    public function getHasErrors()
    {
        return $this->HasErrors;
    }
    /**
     * Set HasErrors value
     * @param bool $hasErrors
     * @return \Api\Aramex\Location\StructType\CitiesFetchingResponse
     */
    public function setHasErrors($hasErrors = null)
    {
        $this->HasErrors = $hasErrors;
        return $this;
    }
    /**
     * Get Cities value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Api\Aramex\Location\ArrayType\ArrayOfstring|null
     */
    public function getCities()
    {
        return isset($this->Cities) ? $this->Cities : null;
    }
    /**
     * Set Cities value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Api\Aramex\Location\ArrayType\ArrayOfstring $cities
     * @return \Api\Aramex\Location\StructType\CitiesFetchingResponse
     */
    public function setCities(\Api\Aramex\Location\ArrayType\ArrayOfstring $cities = null)
    {
        if (is_null($cities) || (is_array($cities) && empty($cities))) {
            unset($this->Cities);
        } else {
            $this->Cities = $cities;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Api\Aramex\Location\StructType\CitiesFetchingResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
